{{
********************************
* jvmMain - top object for JVM *
********************************
}}


CON

  'clock settings for spin stamp
'  _clkmode = xtal1+pll8x
'  _xinfreq = 10_000_000
  'clock settings for propeller board
  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  
  commPort = 1 '0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN

  
OBJ
  jvm:   "jvmEngine"    'the bytecode interpreter
  comm:  "jvmComm"      'communication port object
  jd:    "jvmData"      'jvm memory access object
  'nf:    "jvmNative"    'native functions
  'fmt:   "jvmFormat"    'format functions for jvm debugging
  jprog: "Jazzed_jvmJavaProg"  'storage area for java bytecodes (MUST ONLY BE INCLUDED HERE)

  
DAT
  buf         byte 0[64]

PUB main | c
{{ application starts here }}
  comm.start(commPort,true)
  jvm.start
  'waitcnt(clkfreq*5 + cnt) 'wait 5 second
  comm.setReset
  repeat 'keep running
    jd.init(jprog.getJavaProgram,jprog#JAVASIZE,commPort)  'initialize jvm registers and pass javaProg properties
    if comm.isReset
      comm.doReset
      comm.clearReset
      repeat
        c := comm.doDebug(2000)
      until c == -1
    else
      jvm.setBytecodeAddr(jprog.getJavaProgram)
      'example output for jvm debugging, use [JVM] tag for easy recognition in status window
      'fmt.sprintf(@buf,string("[JVM] debugging started: pc = $%04x"),1024)  ' too fat :<
      comm.status(string("[JVM Main] debug started"))
      'mainloop
      repeat while NOT comm.isReset
        comm.doDebug(0)     'check for debug commands
        c := jvm.doBytecode 'execute next bytecode
        'case c
          '0..47: nf.do_native(c, @nstack)
          'add userdefined native functions here
      